
from os.path import dirname, join, realpath
from setuptools import setup, find_packages, Extension

from karabo.packaging.versioning import device_scm_version

ROOT_FOLDER = dirname(realpath(__file__))
scm_version = device_scm_version(ROOT_FOLDER, join(ROOT_FOLDER, "src", "_version.py"))

REQUIREMENTS = [
    "calngUtils @ git+ssh://git@git.xfel.eu:10022/calibration/calngutils.git",
]


setup(
    name="onlinemid_karabo",
    author="Mads Jakobsen",
    author_email="da-support@xfel.eu",
    description="",
    long_description="",
    url="",
    package_dir={"": "src"},
    packages=find_packages("src"),
    entry_points={
        "karabo.bound_device": [
            "OnlineMIDProcessor = onlinemid_karabo.processor:OnlineMIDProcessor",
            "OnlineXPCSManager = onlinexpcs.onlinexpcsmanager:OnlineXPCSManager",
            "OnlineXPCSCollector = onlinexpcs.onlinexpcscollector:OnlineXPCSCollector",
        ]
    },
    #install_requires=REQUIREMENTS
)
