
#from .utils.image_plotting import OnlineImagePlotter
from onlinemid.utils.image_plotting import OnlineImagePlotter

import matplotlib.pyplot as plt
from matplotlib.backends.backend_agg import FigureCanvasAgg

import numpy as np

class GainStagePlotter():

    def __init__(self):
        self.onlineImagePlotter = OnlineImagePlotter(figsize=(15,10))

    def plot(self, train_id, gainstage_data):

        if gainstage_data.shape[1] != 3:
            print(f"Error, GainStagePlotter.plot received data must be of shape (x, 3), and not {gainstage_data.shape}")
            return
        
        img = self.onlineImagePlotter.get_image_buffer_if_ready_and_make_new_image(train_id, GainStagePlotter.make_plot, gainstage_data, train_id)

        return img
    
    @staticmethod
    def make_plot(data, tid):

        plt.switch_backend("agg")
        fig = plt.figure(figsize=(15,10))

        plt.plot(data)

        plt.title(f"this is my plot for tid {tid}")
        plt.xlabel('mem cell')
        plt.ylabel('number in gain stage')
#        plt.legend('low', 'med', 'high')
        canvas = FigureCanvasAgg(fig)
        canvas.draw()
        image_buffer = np.frombuffer(canvas.buffer_rgba(), dtype=np.uint8).reshape(
        canvas.get_width_height()[::-1] + (4,))
            
        plt.close(fig)
        return image_buffer

    

        